image: python:latest

variables:
  #Gitlab doesn't have a variable for a child-group ("open-source/opentestfactory/site" for this project)
  #Needed to indicate the url for a deployed preview doc or gitlab.com deployment  
  GROUP_CHILD_NAMESPACE: "open-source/opentestfactory"

stages:
  - publish

pages:
  stage: publish
  script:

    - pip install -r requirements.txt
    - mkdocs build --site-dir public

    - echo "Publishing main pages production/${CI_PROJECT_NAME}/${CI_COMMIT_REF_NAME}"
    - echo "Site will be available at https://${CI_PROJECT_ROOT_NAMESPACE}.gitlab.io/${GROUP_CHILD_NAMESPACE}/${CI_PROJECT_NAME}"
  artifacts:
    expire_in: 1 hrs
    paths:
      - public
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
  environment:
    name: production/${CI_PROJECT_NAME}/${CI_COMMIT_REF_NAME}
    url: https://${CI_PROJECT_ROOT_NAMESPACE}.gitlab.io/${GROUP_CHILD_NAMESPACE}/${CI_PROJECT_NAME}
  variables:
    PUBLIC_URL: "https://${CI_PROJECT_ROOT_NAMESPACE}.gitlab.io/${GROUP_CHILD_NAMESPACE}/${CI_PROJECT_NAME}"

pages:preview:
  stage: publish
  script:
    - pip install -r requirements.txt
    - mkdocs build --site-dir public

    - echo "Publishing staging pages preview/${CI_PROJECT_NAME}/${CI_MERGE_REQUEST_SOURCE_BRANCH_NAME}"
    - echo "Site will be available at ${PUBLIC_URL}/index.html"
  artifacts:
    expire_in: 1 hrs
    paths:
      - public
  rules:
    - if: $CI_MERGE_REQUEST_IID
  environment:
    name: preview/${CI_PROJECT_NAME}/${CI_MERGE_REQUEST_SOURCE_BRANCH_NAME}
    url: https://${CI_PROJECT_ROOT_NAMESPACE}.gitlab.io/-/${GROUP_CHILD_NAMESPACE}/${CI_PROJECT_NAME}/-/jobs/${CI_JOB_ID}/artifacts/public/index.html
    on_stop: pages:preview:stop
  variables:
    PUBLIC_URL: "https://${CI_PROJECT_ROOT_NAMESPACE}.gitlab.io/-/${GROUP_CHILD_NAMESPACE}/${CI_PROJECT_NAME}/-/jobs/${CI_JOB_ID}/artifacts/public"

pages:preview:stop:
  stage: publish
  rules:
    - if: $CI_MERGE_REQUEST_IID
      when: manual
  allow_failure: true
  environment:
    name: preview/${CI_PROJECT_NAME}/${CI_MERGE_REQUEST_SOURCE_BRANCH_NAME}
    action: stop
  script:
    - echo "Shutting down staging page preview/${CI_PROJECT_NAME}/${CI_MERGE_REQUEST_SOURCE_BRANCH_NAME}"
